      subroutine aground
     & (thknot, phi, p14, 
     & rlambda, bangs, pkhair, dcell0, 
     & lmod2, ncomp2, ul2, sl2, szz, eln2, thm2, 
     & slw2, rnc2, vai2, dcell2, asp2, ccomp2, 
     & lmod1, ncomp1, ul1, sl1, eln1, thm1,
     & slw1, rnc1, vai1, dcell1, asp1, ccomp1,
     & thss, rsl1, rsl2, rsl3, rsl4, 
     & rsogrou, rdsgrou, rsdgrou, rddgrou)
c
c   Directional-hemispherical reflectance rsdground and albedo 
c   (hemispherical-hemispherical reflectance) rddgrou 
c   of ground vegetation.                          A. Kuusk  5.9.2002
c   Input:
c     & (thknot, phi, p14,
c     & rlambda, bangs, pkhair, dcell0,
c     & lmod2, ncomp2, ul2, sl2, szz, eln2, thm2,
c     & slw2, rnc2, vai2, dcell2, asp2, ccomp2,
c     & lmod1, ncomp1, ul1, sl1, eln1, thm1,
c     & slw1, rnc1, vai1, dcell1, asp1, ccomp1,
c     & thss, rsl1, rsl2, rsl3, rsl4,
c   Output:
c   & rsogrou, rdsgrou, rsdgrou, rddgrou)
c
      include 'frtpar.h'
      include 'nch.h'
c
      character*10 lmod1, lmod2
      dimension ccomp1(ncomp0), ccomp2(ncomp0)
      dimension thknot(nangls), p14(nknots)
c
c           ! Albedo of ground vegetation is calculated integrating
c           ! ACRM with Gauss quadrature in the perpendicular plain
c           ! phi = 90 deg
c
      phis  = phi
      thets = thknot(nknots + 1)
      thetv = thknot(1)
      skyl  = 1.d0
      call smcrm
     &  (thknot, p14, 
     &  lmod2, ncomp2, ul2, sl2, szz, eln2, thm2, 
     &  slw2, rnc2, vai2, dcell2, asp2, ccomp2, 
     &  lmod1, ncomp1, ul1, sl1, eln1, thm1, 
     &  slw1, rnc1, vai1, dcell1, asp1, ccomp1, 
     &  thets, bangs, pkhair, dcell0, rsl1, rsl2, rsl3, rsl4, thss,
     &  thetv, phi, rlambda, skyl, ee1, rn1, refl1, tran1, 
     &  ee2, rn2, refl2, tran2, rsl,
     &  ggv, penalty, bc1, bs1, bdplants, bdsoil)
      sbgr = (1.d0 -skyl)*(bc1 + bs1) + bdplants + bdsoil
      rdsgrou = sbgr
c
      skyl  = 0.d0
      call smcrm
     &  (thknot, p14, 
     &  lmod2, ncomp2, ul2, sl2, szz, eln2, thm2, 
     &  slw2, rnc2, vai2, dcell2, asp2, ccomp2, 
     &  lmod1, ncomp1, ul1, sl1, eln1, thm1, 
     &  slw1, rnc1, vai1, dcell1, asp1, ccomp1, 
     &  thets, bangs, pkhair, dcell0, rsl1, rsl2, rsl3, rsl4, thss,
     &  thetv, phi, rlambda, skyl, ee1, rn1, refl1, tran1, 
     &  ee2, rn2, refl2, tran2, rsl,
     &  ggv, penalty, bc1, bs1, bdplants, bdsoil)
      sbgr = (1.d0 -skyl)*(bc1 + bs1) + bdplants + bdsoil
      rsogrou = sbgr
c
      phi   = pi/2.d0
      rsdgrou = 0.d0
      do i1 = 2, nknots
         thetv   = thknot(i1)
         call smcrm
     &  (thknot, p14, 
     &  lmod2, ncomp2, ul2, sl2, szz, eln2, thm2, 
     &  slw2, rnc2, vai2, dcell2, asp2, ccomp2, 
     &  lmod1, ncomp1, ul1, sl1, eln1, thm1, 
     &  slw1, rnc1, vai1, dcell1, asp1, ccomp1, 
     &  thets, bangs, pkhair, dcell0, rsl1, rsl2, rsl3, rsl4, thss,
     &  thetv, phi, rlambda, skyl, ee1, rn1, refl1, tran1, 
     &  ee2, rn2, refl2, tran2, rsl,
     &  ggv, penalty, bc1, bs1, bdplants, bdsoil)
         sbgr = (1.d0 -skyl)*(bc1 + bs1) + bdplants + bdsoil
         rsdgrou = rsdgrou + p14(i1)*sbgr
      enddo
c
      rddgrou = 0.d0
      do i2 = 2, nknots
         thets = thknot(i2)
         rsdg  = 0.d0
         do i1 = 2, nknots
            thetv   = thknot(i1)
            call smcrm
     &  (thknot, p14, 
     &  lmod2, ncomp2, ul2, sl2, szz, eln2, thm2, 
     &  slw2, rnc2, vai2, dcell2, asp2, ccomp2, 
     &  lmod1, ncomp1, ul1, sl1, eln1, thm1, 
     &  slw1, rnc1, vai1, dcell1, asp1, ccomp1, 
     &  thets, bangs, pkhair, dcell0, rsl1, rsl2, rsl3, rsl4, thss,
     &  thetv, phi, rlambda, skyl, ee1, rn1, refl1, tran1, 
     &  ee2, rn2, refl2, tran2, rsl,
     &  ggv, penalty, bc1, bs1, bdplants, bdsoil)
            sbgr = (1.d0 -skyl)*(bc1 + bs1) + bdplants + bdsoil
            rsdg = rsdg + p14(i1)*sbgr
         enddo
         rddgrou = rddgrou + p14(i2)*rsdg
      enddo
c
      phi = phis
      return
      end
*
************************************************************************
*
