      subroutine diffor
     & (jths, thets, thetv, skyl, efflai, tlty, ggmean, 
     & rteff, tteff, rdsgrou, rsdgrou, rddgrou, budif, bddif)
c
c     Diffuse fluxes in a forest, A. Kuusk 5.09.2002
c     Kuusk, A. (2001) A two-layer canopy reflectance model, J.Q.S.R.T.,
c     71(1): 1-9.
c     rdgrou fixed on 3.08.2009
c     Elliptical orientation of foliage 12.2012
c
c  Input:
c     & (jths, thets, thetv, skyl, efflai, tlty, ggmean,
c     & rteff, tteff, rdsgrou, rsdgrou, rddgrou
c  Output:
c     budif, bddif,  
c  budif - up, bddif - diffuse flux of crown layer, down
c
      include 'frtpar.h'
      include 'nch.h'
*     implicit double precision (a-h, o-z)
      dimension ggmean(nangls)
c
      utot = efflai + tlty
      sq   = 1.d0 - skyl
c
      gcyl = 2.d0*sin(thets)/pi
      ggs  = (efflai*ggmean(jths) + tlty*gcyl)/utot
      ggv  = (efflai*ggmean(1) + tlty*gcyl)/utot
      ggj  = efflai/6.d0/utot
      tsst = exp(-utot*ggs/cos(thets))
      tsvt = exp(-utot*ggv/cos(thetv))
c
      call layer
     & (thets, thetv, ggs, ggv, ggj, utot, rteff, tteff,
     & rddt, tddt, rdot, tdot, rsdt, tsdt, rsot)
c                          r??t, t??t - r?? and t?? for tree layer
c
      fac  = 1.d0/(1.d0 - rddt*rddgrou)
c                                          JQSRT equations (9) and (10)
      rdpl   = sq*rsot + skyl*rdot
     &       + (sq*(tsst*rsdgrou + tsdt*rddgrou) 
     &       + skyl*tddt*rddgrou)*tdot*fac
      rdgrou = (sq*(tsst*rsdgrou*rddt + tsdt) + skyl*tddt)*
     &         rdsgrou*tsvt*fac
      budif  = rdpl + rdgrou
      bddif  = (skyl*tddt + sq*tsdt)*fac
c
      return
      end
*
**********************************************************************
*
