      subroutine het48o
     & (ncl, nsangl, thknot, phi, stdns, sqarr,
     & uuu, eln3, thm3, ghg, efflai, rteff, tteff, tlty, 
     & ggmean, rtrnk, aas, aav, psgvu, bdgfu, bdgfd, btr1uk, btr1dk, 
     & rlambda, bangs, pkhair, dcell0,
     & lmod2, ncomp2, ul2, sl2, szz, eln2, thm2,
     & slw2, rnc2, vai2, dcell2, asp2, ccomp2,
     & lmod1, ncomp1, ul1, sl1, eln1, thm1,
     & slw1, rnc1, vai1, dcell1, asp1, ccomp1,
     & thss, rsl1, rsl2, rsl3, rsl4, rnlf, 
     & rrs, ttt, rdsgrou, rsdgrou, rddgrou, 
     & p2bq, bdown, bqc1, bqg1, bqm)
*    & , totrans, diftrans)
c
c   optical parameters: subroutine het48o(..)  A. Kuusk 26.09.1995
c   subroutine het48(..)  A. Kuusk  7.12.1994,
c   function het48(..),  Anne Jõeveer
c
c  Input:
c     & ncl, nsangl, thknot, phi, stdns, sqarr, 
c     & uuu, eln3, thm3, ghg, efflai, rteff, tteff, tlty, rtrnk,
c     & aas, aav, psgvu, bdgfu, bdgfd, btr1uk, btr1dk,
c     & rlambda, bangs, pkhair, dcell0,
c     & lmod2, ncomp2, ul2, sl2, szz, eln2, thm2,
c     & slw2, rnc2, vai2, dcell2, asp2, ccomp2,
c     & lmod1, ncomp1, ul1, sl1, eln1, thm1,
c     & slw1, rnc1, vai1, dcell1, asp1, ccomp1,
c     & thss, rsl1, rsl2, rsl3, rsl4, rnlf,
c     & rrs, ttt, rdsgrou, rsdgrou, rddgrou
c  Output:
c    p2bq, bdown, bqc1, bqg1, bqm
c
      include 'frtpar.h'
      include 'nch.h'
c
      character*10 lmod1, lmod2
      dimension ccomp1(ncomp0), ccomp2(ncomp0)
      dimension thknot(nangls), p14(nknots)
      dimension stdns(nclmax), uuu(nclmax), 
     & rnlf(nclmax), rtrnk(nclmax)
      dimension eln3(nclmax), thm3(nclmax), ghg(nclmax)
      dimension sqarr(nangls, nspchnl)
      dimension aas(nangls), psgvu(nangls), ggmean(nangls)
      dimension bdgfu(nangls, nclmax), btr1uk(nangls, nclmax)
      dimension bdgfd(nangls, nclmax), btr1dk(nangls, nclmax)
      dimension ttt(nclmax, nspchnl), rrs(nclmax, nspchnl)
*     dimension qqh(nangls), qqx(nangls), p2bq(nangls),
      dimension p2bq(nangls),
     & bi0u(nangls), bi0d(nangls), bdown(nangls)
*     dimension totrans(nangls), diftrans(nangls)
c
*     data dr/1.745329251994330d-2/
c
      jwl  = nint((rlambda - (400.d0 - wlstep))/wlstep)
c
c   single scattering
c
       call hetk8o
     & (ncl, jwl, nsangl, thknot, phi, stdns, uuu, eln3, thm3, 
     & ghg, bdgfu, bdgfd, btr1uk, btr1dk, pkhair, rnlf, rtrnk, 
     & rrs, ttt, bi0u, bi0d)
c
      thetv = thknot(1)
      do iths = nknots+1, nsangl
         jths    = iths - nknots
c
c                                ***  S'/Q from the array sqarr,
c                                     S'/Q - direct to diffuse ratio
         sql   = sqarr(iths, jwl)
         skyl  = 1.d0 - sql
         thets = thknot(iths)
c
c   diffuse fluxes of tree crowns
c
         call diffor
     & (iths, thets, thetv, skyl, efflai, tlty, ggmean, 
     & rteff, tteff, rdsgrou, rsdgrou, rddgrou, budif, bddif)
c
c               ! reflectance of ground vegetation r??grou was calculated
c               ! with 2-layer model ACRMf
c
         skylg = bddif/(aas(iths)*cos(thets)*pi + bddif)
c  bddif is diffuse downward flux under tree layer
c
         call smcrm
     &  (thknot, p14, 
     &  lmod2, ncomp2, ul2, sl2, szz, eln2, thm2, 
     &  slw2, rnc2, vai2, dcell2, asp2, ccomp2, 
     &  lmod1, ncomp1, ul1, sl1, eln1, thm1, 
     &  slw1, rnc1, vai1, dcell1, asp1, ccomp1, 
     &  thets, bangs, pkhair, dcell0, rsl1, rsl2, rsl3, rsl4, thss,
     &  thetv, phi, rlambda, skyl, ee1, rn1, refl1, tran1, 
     &  ee2, rn2, refl2, tran2, rsl,
     &  ggv, penalty, bc1, bs1, bdplants, bdsoil)
         sbgr = (1.d0 - skylg)*(bc1 + bs1) + bdplants + bdsoil
c
         br1gr    = sbgr*psgvu(iths)
*            write (0, *) "PSGVU: ", thetv/dr, thets/dr, psgvu(iths)
         b0       = bi0u(iths) + br1gr
         bq       = sql*b0 + budif
*            write (0, *) thetv/dr, budif
         p2bq(jths) = bq
c                                          reflectance components
         bqc1 = sql*bi0u(iths)
         bqg1 = sql*br1gr
         bqm  = budif
*        b_qc1 = bqc1
*        b_qg1 = bqg1
*        b_qm  = bqm
c                                                  radiance down
         bsngld = bi0d(iths)
         bdown(jths) = (bsngld + bddif) + aav/pi*skyl
*        print *, thetv/dr, 
*    & bsngld, bddif, aav/pi*skyl, bdown(jths)
c
*     print *, thknot(1)/dr, p2bq(jths), totrans(jths), diftrans(jths)
      enddo
c
      return
      end
*
************************************************************************
*
