      subroutine hetk8s
     & (lelli, ncl, shl, nzs, nsangl, thknot, phi,
     & stdns, htr, hc1, hc2, rcr, dbh, gg3, glmp, uuu, 
     & aas, aav, psgvu, bdgfu, bdgfd, btr1uk, btr1dk)
c
c     Gap probabilities               A. Kuusk   1.12.2000
c     Modified for elliptical LAD 3.12.2012
c
c  Input:
c    lelli, ncl, shl, nzs, nsangl, thknot, phi,
c    stdns, htr, hc1, hc2, rcr, dbh, glmp, uuu,
c  Output:
c    aas, aav, psgvu, bdgfu, bdgfd, btr1uk, btr1dk
c
      include 'frtpar.h'
c
      save x1, y1, z1, x2, y2, z2
      logical lelli
c
      dimension lelli(nclmax)
      dimension thknot(nangls)
      dimension shl(nclmax), stdns(nclmax), htr(nclmax), 
     & hc1(nclmax), hc2(nclmax), rcr(nclmax), dbh(nclmax), 
     & glmp(nclmax), uuu(nclmax)
      dimension aas(nangls), psgvu(nangls)
      dimension bdgfu(nangls, nclmax), btr1uk(nangls, nclmax)
      dimension bdgfd(nangls, nclmax), btr1dk(nangls, nclmax)
      dimension gg3(nangls, nclmax)
c
      data x1, y1, z1, x2, y2, z2, x3, y3, z3 /9*0.d0/
c
      rlls1 = 0.d0
      rllv1 = 0.d0
      rllv3 = 0.d0
c                                    **** incident angle loop ****
      thetv  = thknot(1)
      sthetv = sin(thetv)
      cthetv = cos(thetv)
      sthets = sthetv
      cthets = cthetv
c                 The gap probability in view direction aav on ground
      z1     = 0.d0
      sphi   = 0.d0
      cphi   = 1.d0
      chs1   = 0.d0
      chs3   = 0.d0
      calph  = 1.d0
      jths   = 1
c
      z0x = 0.d0
      call aazvun
     & (lelli, ncl, stdns, htr, hc1, hc2, rcr, dbh, uuu, glmp,
     & gg3, z0x, thetv, aav)
c
      sphi   = sin(phi)
      cphi   = cos(phi)
c
      do jths = 1, nsangl
         thets  = thknot(jths)
c   thknot() is the set of polar angles - the knots of Gauss quadrature,
c   gap probability in direction thets on ground, aas(thets)
         sthets = sin(thets)
         cthets = cos(thets)
         chs1   = 0.d0
         calph  = 1.d0
c
         call aazvun
     &    (lelli, ncl, stdns, htr, hc1, hc2, rcr, dbh, uuu, glmp,
     &    gg3, z0x, thets, aasj)
c        aas(jths) is the gap probability in directon thets at level z1
         aas(jths) = aasj
c
      enddo
c
      do jths = 2, nsangl
         thets    = thknot(jths)
c                              p(sunlit, ground) ja pooui(maapinnal)
         sthets = sin(thets)
         cthets = cos(thets)
         calph  = sthetv*sthets*cphi + cthetv*cthets
c
         call spooj
     & (lelli, ncl, jths, uuu, shl, stdns, htr, hc1, hc2, rcr, dbh,
     & gg3, glmp, x1, y1, z1, x2, y2, z2, x3, y3, z3,
     & rlls1, rllv1, rllv3, sthets, cthets, sthetv, cthetv,
     & sphi, cphi, calph, chs1, chs3, poouj, poodj)
c
         psgvu(jths) = poouj
c
         do jcl = 1, ncl
            call enel
     & (lelli, jcl, jths, ncl, shl, stdns, htr, dbh, hc1, hc2, rcr, 
     & uuu, gg3, glmp, thets, thetv, phi, nzs, 
     & bdgfu, bdgfd, btr1uk, btr1dk)
c
         enddo
c 
      enddo
c
      return
      end
*
************************************************************************
*
