      subroutine optmean
     & (jwl, ncl, stdns, htr, hc1, hc2, dbh, rlai, rbai, clmpsh, tlty, 
     & tlaief, tbai, rlfcl, tlfcl, rnlf, rbrnc, rtrnk, 
     & rleff, tleff, rneff, rty, rrs, ttt, utot, rteff, tteff)
c
c  the mean values of optical parameters    A. Kuusk 23.09.1995
c
c  Input:
c    & (jwl, ncl, stdns, htr, hc1, hc2, dbh, rlai, rbai, clmpsh, tlty,
c    & tlaief, tbai, rlfcl, tlfcl, rnlf, rbrnc, rtrnk,
c    & rleff, tleff, rneff, rty, rrs, ttt
c  Output:
c    utot, rteff, tteff
c
c  utot - total effective LAI (leaves + branches + stems)
c  rteff - total efffective leaf reflectance
c  tteff - total efffective leaf transmittance
c
      include 'frtpar.h'
      include 'nch.h'
c
      dimension stdns(nclmax), htr(nclmax), hc1(nclmax), 
     & hc2(nclmax), dbh(nclmax), rlai(nclmax), rbai(nclmax), 
     & clmpsh(nclmax), rlfcl(nclmax), tlfcl(nclmax), 
     & rnlf(nclmax), rbrnc(nclmax), rtrnk(nclmax)
      dimension ttt(nclmax, nspchnl), rrs(nclmax, nspchnl)
c
*     data pi/3.14159265358979d0/
c
      sum2   = 0.d0
c
      do j = 1, ncl
         stdnsj  = stdns(j)
         htrj    = htr(j)
         hcrj    = hc1(j) + hc2(j)
         cli     = stdnsj*dbh(j)*.5d0*(htrj - hcrj)
         sum2    = sum2 + cli*rtrnk(j)
      enddo
c
      rty    = 0.d0
      if (tlty .ne. 0.d0) rty = sum2*pi/tlty
c
      sul0   = 0.d0
      sumn   = 0.d0
      sut    = 0.d0
      rteff  = 0.d0
      tteff  = 0.d0
c
      do jcl = 1, ncl
         rlaief       = rlai(jcl)*clmpsh(jcl)
         baicl        = rbai(jcl)
         claief       = rlaief + baicl
         rdlf         = (rlaief*rlfcl(jcl) + baicl*rbrnc(jcl))
         rrs(jcl, jwl) = rdlf/claief
c
         rteff        = rteff + (rlfcl(jcl) + 
     &     ((1.d0 - rnlf(jcl))/(1.d0 + rnlf(jcl)))**2)*rlaief + 
     &     rbrnc(jcl)*baicl
         ttl          = rlaief*tlfcl(jcl)
         tteff        = tteff + ttl
         ttt(jcl, jwl) = ttl/claief
c
         sul0    = sul0 + rdlf
         sut     = sut + ttl
         sumn    = sumn + rlaief*rnlf(jcl)
      enddo
c
      suml  = tlaief + tbai
      utot  = suml + tlty
      rteff = (rteff + rty*tlty)/utot
      tteff = tteff/utot
      rneff = 1.d0
      if (tlaief .ne. 0.d0) rneff = sumn/tlaief
      tleff = sut/suml
      r12   = sul0/suml
      rleff = r12 + ((rneff - 1.d0)/(rneff + 1.d0))**2
c
      return
      end
*
************************************************************************
*
