      subroutine pi11u
     & (tgthx, zz12, htrj, cellj, rcrj, szux, vzui)
c                                                 A. Kuusk  16.11.2000
c   The projection szux and volume vzui of the upper part 
c   of an ellipsoid at the level zz12 in direction thx
c  Input:
c    tgthx, zz12, htrj, cellj, rcrj
c  Output:
c    szux, vzui
c   tgthx = tan(thx), htrj - tree height,
c   cellj - the semiaxis of the ellips, rcrj - crown radius
c
      include 'frtpar.h'
      include 'nch.h'
c      
      data eps/.1d-4/
c                                                   above the crown
      if (zz12 .ge. htrj) then
         szux = 0.d0
         vzui = 0.d0
         return
      endif
c
      hcrown = 2.d0*cellj
      hbase  = htrj - hcrown
c                                                              stem
      if (zz12 .ge. 0.d0 .and. zz12 .le. hbase) then
         szux = sqrt(rcrj**2 + (cellj*tgthx)**2)*pi*rcrj
         vzui = 4.d0*pi*rcrj**2*cellj/3.d0
         return
      endif
c
      hcent = htrj - cellj
      zx    = zz12 - hcent
      vzui  = pi*rcrj**2*(hcrown/3.d0 - zx + zx**3/3.d0/cellj**2)
      if (vzui .lt. 0.d0) vzui = 0.d0
c                                           the height of intersection
c                                                   puutepunkti kõrgus
      if (tgthx .lt. eps) then
         z0 = 0.d0
      else
         z0 = cellj/sqrt(rcrj/(cellj*tgthx)**2 + 1.d0) 
      endif
c
      rz = sqrt(cellj**2 - zx**2)*rcrj/cellj
      if (abs(zx) .ge. z0) then
c                                                   top of crown
         if (zz12 .gt. hcent) then
            szux = pi*rz**2
         else
c                                                   lower part of crown
            szux = sqrt(rcrj**2 + (cellj*tgthx)**2)*pi*rcrj
         endif
      else
c                                           between intersection points
         xyz  = sqrt(rcrj**2 + (cellj*tgthx)**2)
         beta = acos(zx*tgthx/xyz)
         sel1 = rcrj*xyz*beta - rz*zx*tgthx
         sel2 = pi*rz**2/2.d0
         szux = sel1 + sel2
      endif
      return
      end
*
************************************************************************
*
