      subroutine pi22d
     & (tgthx, zz12, htrj, hc1j, hc2j, rcrj, szdx, vzdi)
c                                       A. Kuusk   14.11.2000
c   The projection szdx and volume vzdi of the lower part 
c   of tree crown at the level zz12 in direction thx, cylinder+cone
c  Input:
c    tgthx, zz12, htrj, hc1j, hc2j, rcrj
c  Output:
c    szdx, vzdi
c   tgthx = tan(thx), htrj - tree height,
c   hc1j, hc2j - the lengths of cone and cylinder, rcrj - crown radius
c
      include 'frtpar.h'
      include 'nch.h'
c      
*     data pi/3.14159265358979d0/
c
*     if (zz12 .lt. 0.d0) then
*        print *, 'Error: z = ', zz12
*        stop
*     endif
c
      hbase  = htrj - (hc1j + hc2j)
c                                                   stem
      if (zz12 .le. hbase) then
         szdx = 0.d0
         vzdi = 0.d0
         return
      endif
c
      vcrown = rcrj**2*pi*(hc1j/3.d0 + hc2j)
      scyl   = 2.d0*hc2j*rcrj*tgthx
c                                                   z > htrj
      if (zz12 .ge. htrj) then
         vzdi   = vcrown
         call scone(hc1j, hc1j, rcrj, tgthx, scon)
         scrown = scyl + scon
         szdx   = scrown
         return
      endif
c                                                   cylinder
      hcbase = htrj - hc1j
      if (zz12 .lt. hcbase) then
         vzdi  = rcrj**2*pi*(zz12 - hbase)
         scyld = 2.d0*rcrj*tgthx*(zz12 - hbase)
         szdx  = scyld + rcrj**2*pi
         return
      endif
c                                                   cone
      hcz  = htrj - zz12
      rcz  = hcz*rcrj/hc1j
      vzui = rcz**2*pi*hcz/3.d0
      vzdi = vcrown - vzui
      call scone(hc1j, hcz, rcrj, tgthx, scdx)
      szdx = scdx + scyl
c
      return
      end
*
************************************************************************
*
