      subroutine rspec(frefr, fprice, fcoef1, ncomp1, 
     & fcoef2, ncomp2, fcoef3, ncomp3, ncl)
c                       Read tabulated spectra. A. Kuusk, 21.02.2002
c
c  Input:
c    frefr, fprice, fcoef1, ncomp1,
c    & fcoef2, ncomp2, fcoef3, ncomp3, ncl
c  Output:
c    refr, phis, acoef? in common areas /spectra/ and /spectra3/
c
      include 'frtpar.h'
      include 'nch.h'
      include 'spec.h'
      include 'spec3.h'
c
      character*77 fname
      character*40 frefr, fprice, fcoef1, fcoef2, fcoef3
      dimension fcoef1(ncomp0), fcoef2(ncomp0), 
     & fcoef3(nclmax, ncomp0)
      dimension ncomp3(nclmax)
c
c                                  Read refraction index
      ire = 2
      fname = frefr
      open (ire, file = fname, status = 'old', err = 99)
         rewind ire
         jl = 1
         read (ire, '(/)', err = 98)
         do jw = 1, nspchnl
            jl = jw + 2
            read (ire, *, err = 98)
     &      wlght, refr(jw)
         enddo
      close (ire)
c                                  Read Price' vectors
      fname = fprice
      open (ire, file = fname, status = 'old', err = 99)
         rewind ire
         jl = 1
         read (ire, '(/)', err = 98)
         do jw = 1, nspchnl
            jl = jw + 2
            read (ire, *, err = 98)
     &      wlght, (phis(jw, j), j = 1, 4)
         enddo
      close (ire)
c                                  Read absorption spectra
      do jc = 1, ncomp1
         fname = fcoef1(jc)
         open (ire, file = fname, status = 'old', err = 99)
         rewind ire
         jl = 1
         read (ire, '(/)', err = 98)
         do jw = 1, nspchnl
            jl = jw + 2
            read (ire, *, err = 98) wlght, acoef1(jw, jc)
         enddo
         close (ire)
      enddo
c
      do jc = 1, ncomp2
         fname = fcoef2(jc)
         open (ire, file = fname, status = 'old', err = 99)
         rewind ire
         jl = 1
         read (ire, '(/)', err = 98)
         do jw = 1, nspchnl
            jl = jw + 2
            read (ire, *, err = 98) wlght, acoef2(jw, jc)
         enddo
         close (ire)
      enddo
c
      do jcl = 1, ncl
         do jc = 1, ncomp3(jcl)
            fname = fcoef3(jcl, jc)
            open (ire, file = fname, status = 'old', err = 99)
            rewind ire
            jl = 1
            read (ire, '(/)', err = 98)
            do jw = 1, nspchnl
               jl = jw + 2
               read (ire, *, err = 98) wlght, acoef3(jcl, jw, jc)
            enddo
            close (ire)
         enddo
      enddo
      return
98    write (*, '(3a, i4)') 
     &      'Error in the file ', fname, 'line ', jl
      stop 'RSPEC'
99    write (*, '(a)')  'File not found: ', fname
      stop 'RSPEC'
      end
*
************************************************************************
*
